//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "uCity.h"
#include "Globe5Utils.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmCityObject *frmCityObject;
Extended gCityLong;
Extended gCityLat;

template<typename T>
T cast_interface( const TObject *obj )
{
  T result;

  if ( Supports( obj, __uuidof(T), &result ) == false )
    throw EIntfCastError( "Interface not supported" );

  return result;
};

//---------------------------------------------------------------------------
__fastcall TfrmCityObject::TfrmCityObject(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmCityObject::ModifyCity( _di_IGMapPoint City )
{
  Caption = "Modify City";

  edtName->Text = City->Attribute[0];
  gCityLong = GUToDD( City->Centroid.iLongX );
  edtLong->Text = FloatToStr( gCityLong );
  gCityLat = GUToDD( City->Centroid.iLatY );
  edtLat->Text = FloatToStr( gCityLat );

  if ( ShowModal() == mrOk )
  {
    if ( Trim( edtName->Text ) != "" )
    {
      City->Edit();
      City->Attribute[0] = edtName->Text;
      City->Centroid = PointLL( DDToGU( gCityLong ), DDToGU( gCityLat ));
      City->Post();
    }
  }
}

//---------------------------------------------------------------------------
void __fastcall TfrmCityObject::NewCity( TGLayer *CityLayer )
{
  TGMapPoint *mapObj;

  Caption = "Add new City";

  edtName->Text = "New City";

  gCityLong = 0;
  edtLong->Text = "0";
  gCityLat = 0;
  edtLat->Text = "0";

  if( ShowModal() == mrOk )
  {
    if ( Trim( edtName->Text ) != "" )
    {
      mapObj = new TGMapPoint;
      mapObj->Attribute[0] = edtName->Text;
      mapObj->Centroid = PointLL( DDToGU( gCityLong ), DDToGU( gCityLat ));
      mapObj->PresenterID = 1;

      CityLayer->ObjectSource->Add(cast_interface<_di_IGMapPoint>(mapObj));
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TfrmCityObject::edtLongChange(TObject *Sender)
{
  if ( Trim( edtLong->Text ) != "" )
    gCityLong = StrToFloatDef( edtLong->Text, gCityLong );
}
//---------------------------------------------------------------------------
void __fastcall TfrmCityObject::edtLatChange(TObject *Sender)
{
  if ( Trim( edtLat->Text ) != "" )
    gCityLat = StrToFloatDef( edtLat->Text, gCityLat );
}
//---------------------------------------------------------------------------
