//---------------------------------------------------------------------------

#ifndef uMainH
#define uMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "GClasses.hpp"
#include "Globe5.hpp"
#include "GSpatialDatabase.hpp"
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TfrmMain : public TForm
{
__published:	// IDE-managed Components
  TSplitter *Splitter2;
  TPanel *Panel1;
  TSplitter *Splitter1;
  TPanel *Panel3;
  TLabel *Label1;
  TEdit *edtFilter;
  TListBox *lbxCities;
  TStringGrid *grdWayPoints;
  TPanel *pnlHint;
  TPanel *Panel4;
  TSpeedButton *SpeedButton1;
  TSpeedButton *SpeedButton2;
  TSpeedButton *btnWorld;
  TBitBtn *btnZoomIn;
  TBitBtn *btnZoomOut;
  TGlobe5 *Globe;
  TMainMenu *MainMenu1;
  TMenuItem *Exit1;
  TMenuItem *About1;
  TPopupMenu *PopupMenu1;
  TMenuItem *LocateCity1;
  TMenuItem *AddCity1;
  TMenuItem *ModifyCity1;
  TMenuItem *N1;
  TMenuItem *DeleteCity1;
  TGSpatialDatabase *sdb;
  TTimer *Timer1;
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall btnWorldClick(TObject *Sender);
  void __fastcall edtFilterChange(TObject *Sender);
  void __fastcall lbxCitiesDblClick(TObject *Sender);
  void __fastcall grdWayPointsDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept);
  void __fastcall grdWayPointsDragDrop(TObject *Sender, TObject *Source,
          int X, int Y);
  void __fastcall GlobeRender(TObject *Sender);
  void __fastcall SpeedButton1Click(TObject *Sender);
  void __fastcall SpeedButton2Click(TObject *Sender);
  void __fastcall grdWayPointsDblClick(TObject *Sender);
  void __fastcall About1Click(TObject *Sender);
  void __fastcall Exit1Click(TObject *Sender);
  void __fastcall btnZoomInClick(TObject *Sender);
  void __fastcall btnZoomOutClick(TObject *Sender);
  void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
  void __fastcall PopupMenu1Popup(TObject *Sender);
  void __fastcall DeleteCity1Click(TObject *Sender);
  void __fastcall LocateCity1Click(TObject *Sender);
  void __fastcall ModifyCity1Click(TObject *Sender);
  void __fastcall AddCity1Click(TObject *Sender);
  void __fastcall GlobeMouseWheelDown(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
  void __fastcall GlobeMouseWheelUp(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall GlobeMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
private:	// User declarations
    TGLayer *ctyLayer;
    TGPOZ FPozStart, FPozDest;
    int FStepCounter;
    Extended FZoomInSF, FZoomOutSF;
    void __fastcall StartEasing( int iLongX, int iLatY );
    void __fastcall ShowHint( TObject *Sender );
    void __fastcall BuildWayPointList();
    void __fastcall AddWayPoint( TGPrimaryKey objPK );
public:		// User declarations
  __fastcall TfrmMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMain *frmMain;
//---------------------------------------------------------------------------
#endif
