unit Ucity;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, GClasses, GMapObjects, GSysUtils;

type
  TfrmCityObject = class(TForm)
    edtName: TEdit;
    Label1: TLabel;
    edtLong: TEdit;
    edtLat: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure edtLongChange(Sender: TObject);
    procedure edtLatChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ModifyCity( City : IGMapPoint );
    procedure NewCity( CityLayer : TGLayer );
  end;

var
  frmCityObject: TfrmCityObject;
  gCityLong, gCityLat : Extended;

implementation

{$R *.DFM}

procedure TfrmCityObject.NewCity( CityLayer : TGLayer );
var
  mapObj : TGMapPoint;
begin
  Caption := 'Add new City';

  edtName.Text := 'New City';
  gCityLong := 0;
  edtLong.Text := '0';
  gCityLat := 0;
  edtLat.Text := '0';

  if ShowModal = mrOK then
    if Length( edtName.Text ) > 0 then
    begin
      mapObj := TGMapPoint.Create;
      mapObj.Attribute[0] := edtName.Text;
      mapObj.Centroid := PointLL(DDToGU( gCityLong ),DDToGU( gCityLat ));
      mapObj.PresenterID := 1;

      CityLayer.ObjectSource.Add(mapObj);
    end;
end;

procedure TfrmCityObject.ModifyCity( City : IGMapPoint );
begin
  Caption := 'Modify City';

  edtName.Text := City.Attribute[0];
  gCityLong := GUToDD( City.Centroid.iLongX );
  edtLong.Text := Format( '%f', [gCityLong]);
  gCityLat := GUToDD( City.Centroid.iLatY );
  edtLat.Text := Format( '%f', [gCityLat]);

  if ShowModal = mrOK then
    if Length( edtName.Text ) > 0 then
    begin
      City.Edit;
      City.Attribute[0] := edtName.Text;
      City.Centroid := PointLL(
      DDToGU( gCityLong ),
      DDToGU( gCityLat ));
      City.Post;
    end;
end;

procedure TfrmCityObject.edtLongChange(Sender: TObject);
begin
  with edtLong do
    if Length( Text ) > 0 then
    try
      gCityLong := StrToFloat( Text );
    except
      Text := Format( '%f', [ gCityLong ] );
    end;
end;

procedure TfrmCityObject.edtLatChange(Sender: TObject);
begin
  with edtLat do
    if Length( Text ) > 0 then
    try
      gCityLat := StrToFloat( Text );
    except
      Text := Format( '%f', [ gCityLat ] );
    end;
end;

end.
