{------------------------------------------------------------------------------
  Multiple View demo program

 	Displays several views of the same spatial database data using multiple
  globe components.
  Shows that the globes can display the same data in different ways by adding
  different Presenters to the globe layers.

------------------------------------------------------------------------------}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, GSpatialDatabase, GClasses, Globe5, GSysUtils, GPresenters;

type
  TForm1 = class(TForm)
    sdb: TGSpatialDatabase;
    Globe2: TGlobe5;
    Globe: TGlobe5;
    Panel1: TPanel;
    Globe1: TGlobe5;
    procedure GlobeMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.GlobeMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  ptLL : TGPointLL;
begin
  // if the mouse is over the surface of the globe.
  // adjust Globe1 to be centered at the same location as the mouse.
  if TGlobe5( Sender).Projector.DeviceXYToLL(X, Y, ptLL) then
  begin
    Globe1.Projector.ScaleFactor := TGlobe5( Sender).Projector.ScaleFactor * 5;
    Globe1.LocateToLL(ptLL);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  aLayer : TGLayer;
  aPresenter : TGPresenter;
begin
  sdb.Active := true;

  // Add a presenter to the TGWorld layer on Globe2 so that the countrys show
  // up in Blue.
  aLayer := Globe2.GlobeLayer.LayerStore.LayerByName('TGWorld');
  if aLayer <> nil then
  begin
    aPresenter := aLayer.ObjectSource.Presenters.ByID(1);

    if ( aPresenter <> nil ) and ( aPresenter is TGPolyPresenter ) then
      TGPolyPresenter( aPresenter ).PolyBrush.Color := clBlue;
  end;
end;

end.
